---
title: CanvasRenderingContext2D.fillStyle
slug: Web/API/CanvasRenderingContext2D/fillStyle
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Property
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.fillStyle</code></strong> property of the <a href="/en-US/docs/Web/API/Canvas_API">Canvas 2D API</a> specifies the color, gradient, or pattern to use inside shapes. The default style is <code>#000</code> (black).</p>

<div class="note">
<p>For more examples of fill and stroke styles, see <a href="/en-US/docs/Web/API/Canvas_API/Tutorial/Applying_styles_and_colors">Applying styles and color</a> in the <a href="/en-US/docs/Web/API/Canvas_API/Tutorial">Canvas tutorial</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>ctx</em>.fillStyle = <em>color</em>;
<em>ctx</em>.fillStyle = <em>gradient</em>;
<em>ctx</em>.fillStyle = <em>pattern</em>;
</pre>

<h3 id="Options">Options</h3>

<dl>
 <dt><code>color</code></dt>
 <dd>A {{domxref("DOMString")}} parsed as <a href="/en-US/docs/Web/CSS">CSS</a> {{cssxref("&lt;color&gt;")}} value.</dd>
 <dt><code>gradient</code></dt>
 <dd>A {{domxref("CanvasGradient")}} object (a linear or radial gradient).</dd>
 <dt><code>pattern</code></dt>
 <dd>A {{domxref("CanvasPattern")}} object (a repeating image).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Changing_the_fill_color_of_a_shape">Changing the fill color of a shape</h3>

<p>This example applies a blue fill color to a rectangle.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.fillStyle = 'blue';
ctx.fillRect(10, 10, 100, 100);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Changing_the_fill_color_of_a_shape', 700, 160) }}</p>

<h3 id="Creating_multiple_fill_colors_using_loops">Creating multiple fill colors using loops</h3>

<p>In this example, we use two <code>for</code> loops to draw a grid of rectangles, each having a different fill color. To achieve this, we use the two variables <code>i</code> and <code>j</code> to generate a unique RGB color for each square, and only modify the red and green values. (The blue channel has a fixed value.) By modifying the channels, you can generate all kinds of palettes.</p>

<div class="hidden">
<pre class="brush: html">&lt;canvas id="canvas" width="150" height="150"&gt;&lt;/canvas&gt;</pre>
</div>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

for (let i = 0; i &lt; 6; i++) {
  for (let j = 0; j &lt; 6; j++) {
    ctx.fillStyle = `rgb(
        ${Math.floor(255 - 42.5 * i)},
        ${Math.floor(255 - 42.5 * j)},
        0)`;
    ctx.fillRect(j * 25, i * 25, 25, 25);
  }
}
</pre>

<p>The result looks like this:</p>

<p>{{EmbedLiveSample("Creating_multiple_fill_colors_using_loops", 160, 160, "https://mdn.mozillademos.org/files/5417/Canvas_fillstyle.png")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-fillstyle", "CanvasRenderingContext2D.fillStyle")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.fillStyle")}}</p>

<h3 id="WebKitBlink-specific_note">WebKit/Blink-specific note</h3>

<p>In WebKit- and Blink-based browsers, the non-standard and deprecated method <code>ctx.setFillColor()</code> is implemented in addition to this property.</p>

<pre class="brush: js">setFillColor(color, optional alpha);
setFillColor(grayLevel, optional alpha);
setFillColor(r, g, b, a);
setFillColor(c, m, y, k, a);
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Canvas_API">Canvas API</a></li>
 <li>The interface defining this property: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>Values used by this property:
  <ul>
   <li>{{cssxref("&lt;color&gt;")}} CSS data type</li>
   <li>{{domxref("CanvasGradient")}} object</li>
   <li>{{domxref("CanvasPattern")}} object</li>
  </ul>
 </li>
</ul>
